/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_CECMANAGERSTATUS_H__991BF957_8868_11D3_9A95_00500447FC27__INCLUDED_)
#define AFX_CECMANAGERSTATUS_H__991BF957_8868_11D3_9A95_00500447FC27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECManagerStatus.h : header file
//
#include "CORBA/CORBAClient.h"
#include "CORBA/CORBAServer.h"
#include "CORBAObjects\TestManager.h"
#include <afxtempl.h>

struct MANAGER_INFO
{
    CString szRegName;
    CString szUser;
    CString szTime;
    CString szProject;
    CString szNode;
    CString szTest;
    int nPID;
    BOOL bAuditLogging;
}
typedef MANAGER_INFO;


#define WMU_SHOW_DETAILS                    (WM_USER+9601)
#define WMU_INJECTOR_VIEW                   (WM_USER+9603)
#define WMU_LOGAUDIT                        (WM_USER+9604)
/////////////////////////////////////////////////////////////////////////////
// CECManagerStatus dialog

class CECManagerStatus : public CDialog
{
    // Construction
public:
    CECManagerStatus(CWnd* pParent = NULL);   // standard constructor
    virtual ~CECManagerStatus();

    // Dialog Data
    //{{AFX_DATA(CECManagerStatus)
    enum { IDD = IDD_MANAGER_DLG };
    CListCtrl   m_ManagerList;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECManagerStatus)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CECManagerStatus)
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnTimer(UINT nIDEvent);
    afx_msg void OnClose();
    afx_msg void OnDblclkManagerList(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    afx_msg void OnPaint();
    afx_msg void OnItemchangedManagerList(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
    afx_msg void OnFilter();
    afx_msg void OnFullHelp();
    //}}AFX_MSG
    afx_msg void OnInjectorView();
    afx_msg void OnShowDetails();
    afx_msg void OnKillTest();
    afx_msg void OnLogAudit();
    afx_msg void OnLogAuditStop();

    DECLARE_MESSAGE_MAP()
private:
    CString m_szHtmlHelpFile;
    int GetManagerIndex(CString szRegName);
    void RemoveFinishedItems(CString RegList);
    void DoUpdate();

    int m_AnchorPos;
    int m_nColumnCount;

    CString m_strUserFilter;
    CString m_strInjectorFilter;
    CString m_strProjectFilter;

    void ApplyFilters();
    void UpdateManagerArray();
    void SetupColumns();
    int GetCurrentSelection();
    CORBAClient* m_pCorbaClt;
    BOOL GetStatusInfo(MANAGER_INFO &info);
    CArray <MANAGER_INFO,MANAGER_INFO> m_ManagerArray;

    CMapStringToString m_mapIPToName;

    bool m_bUpdating;
    LRESULT OnRefreshComplete(WPARAM,LPARAM);
    static UINT UpdateThread(LPVOID);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECMANAGERSTATUS_H__991BF957_8868_11D3_9A95_00500447FC27__INCLUDED_)
