/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// GridCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "xotaeditor.h"
#include "CyrGridCtrl.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CYRGridCtrl

CYRGridCtrl::CYRGridCtrl()
{
    EnableTitleTips(FALSE);
}

CYRGridCtrl::~CYRGridCtrl()
{}



BEGIN_MESSAGE_MAP(CYRGridCtrl, CECGridCtrl)
//{{AFX_MSG_MAP(CYRGridCtrl)
ON_WM_RBUTTONDOWN()
ON_WM_LBUTTONDOWN()
ON_WM_LBUTTONUP()
ON_WM_MOUSEMOVE()
ON_WM_NCHITTEST()
ON_WM_CHAR()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CYRGridCtrl message handlers
void  CYRGridCtrl::OnEditCell(int nRow, int nCol, CPoint point, UINT nChar)
{
    LRESULT lResult = ::SendMessage(GetParent()->GetSafeHwnd(),WMU_CAN_START_EDITING,nRow,nCol);
    BOOL bCanEdit = lResult;
    if (bCanEdit)
    {
        CECGridCtrl::OnEditCell(nRow, nCol, point, nChar);
    }
}

void   CYRGridCtrl::OnEndEditCell(int nRow, int nCol, CString str)
{
    LRESULT lResult = ::SendMessage(GetParent()->GetSafeHwnd(),WMU_VALIDATE_CELL,nRow,nCol);
    BOOL bValid = lResult;
    if (bValid)
    {
        CECGridCtrl::OnEndEditCell(nRow, nCol, str);
    }
    else
    {
        SetFocusCell(nRow, nCol);
    }
}

void CYRGridCtrl::OnRButtonDown(UINT nFlags, CPoint point)
{
    CMenu menuContext;
    menuContext.LoadMenu(IDR_CONTEXT_MENU);

    CMenu* pPopup = menuContext.GetSubMenu(0);

    CPoint pt(point);
    ClientToScreen(&pt);

    if(pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x,  pt.y,GetParent(), NULL))
    {
        return;
    }

    CECGridCtrl::OnRButtonDown(nFlags, point);
}
/*
BOOL CYRGridCtrl::GetStyleRowCol(ROWCOL nRow, ROWCOL nCol, CGXStyle& style, GXModifyType mt, int nType)
{
    // Load stored style information of the cell
    BOOL bRet = CGXGridCore::GetStyleRowCol(nRow, nCol, style, mt, nType);
 
    // Check invert state for individual cell
    if (nType == 0 && GetInvertStateRowCol(nRow, nCol, GetParam()->GetRangeList())  
        && !IsCurrentCell(nRow,nCol))
    {   
       style.SetInterior(::GetSysColor(COLOR_HIGHLIGHT));
       style.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
       bRet = TRUE;
    }
    
    return bRet;
}
*/

//void CYRGridCtrl::DrawInvertCell(CDC* /*pDC*/, ROWCOL nRow, ROWCOL nCol, CRect rectItem)
//{
// If DrawInvertCell has been called from OnDrawTopLeftBottomRight
// m_nNestedDraw is greater 0. There is no invalidation of the rectange
// necessary because the cell has already been drawn.

//    if (m_nNestedDraw == 0)
//    {
// m_nNestedDraw equal to 0 means that PrepareChangeSelection,
// PrepareClearSelection or UpdateSelectRange did call this method.

//       CGXRange range;
//       if (GetCoveredCellsRowCol(nRow, nCol, range))
//          rectItem = CalcRectFromRowCol(range.top, range.left, range.bottom, range.right);

//       InvalidateRect(&rectItem);
//    }
//}
/*
void CYRGridCtrl::OnClickedButtonRowCol(ROWCOL nRow, ROWCOL nCol)
{
    ::SendMessage(GetParent()->GetSafeHwnd(),WMU_BUTTON_PRESSED,nRow,nCol);
}
*/
void CYRGridCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
    RelayEvent(WM_LBUTTONDOWN, (WPARAM)nFlags,
               MAKELPARAM(LOWORD(point.x), LOWORD(point.y)));

    CECGridCtrl::OnLButtonDown(nFlags, point);
}

void CYRGridCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
    RelayEvent(WM_LBUTTONUP, (WPARAM)nFlags,
               MAKELPARAM(LOWORD(point.x), LOWORD(point.y)));

    CECGridCtrl::OnLButtonUp(nFlags, point);
}

void CYRGridCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
    RelayEvent(WM_MOUSEMOVE, (WPARAM)nFlags,
               MAKELPARAM(LOWORD(point.x), LOWORD(point.y)));

    CECGridCtrl::OnMouseMove(nFlags, point);
}


void CYRGridCtrl::RelayEvent(UINT message, WPARAM wParam, LPARAM lParam)
{
    if (NULL != m_ctlToolTip.m_hWnd)
    {
        MSG msg;

        msg.hwnd= m_hWnd;
        msg.message= message;
        msg.wParam= wParam;
        msg.lParam= lParam;
        msg.time= 0;
        msg.pt.x= LOWORD (lParam);
        msg.pt.y= HIWORD (lParam);

        m_ctlToolTip.RelayEvent(&msg);
    }
}

void CYRGridCtrl::PreSubclassWindow()
{
    //
    //  Tool tips do not seem to work for the grid control if it is in an OCX
    //  therefore we need to handle them manually
    //

    //Create a tool tip control if one doesnot already exist
    if(m_ctlToolTip.GetSafeHwnd()==NULL)
    {
        if (!m_ctlToolTip.Create(this))
            TRACE0("Unable to create tip window.");
        else
            if (!m_ctlToolTip.AddTool(this, LPCTSTR("")))
                TRACE0("Unable to add tips to the grid.");
            else
            {
                m_ctlToolTip.Activate(true); //enable the tooltips
                m_ctlToolTip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX);
                m_ctlToolTip.SendMessage(TTM_SETDELAYTIME, TTDT_AUTOPOP, SHRT_MAX);
                m_ctlToolTip.SendMessage(TTM_SETDELAYTIME, TTDT_INITIAL, 200);
                m_ctlToolTip.SendMessage(TTM_SETDELAYTIME, TTDT_RESHOW, 200);
            }
    }

    CECGridCtrl::PreSubclassWindow();
}

UINT CYRGridCtrl::OnNcHitTest(CPoint point)
{
    /*
        CPoint pt(point);
        ScreenToClient(&pt);
     
        CString strTipTextNew;
        
        ROWCOL nRow,nCol;
        
        switch( HitTest(pt, &nRow,&nCol) )
        {
        case GX_CELLHIT:
        {
            strTipTextNew = GetItemText(nRow,nCol);
     
            //If this column is a combo box, only the key will be in the tip text
            //so we must convert this to a text value
            CGXStyle style;
            GetColStyle(nCol,style);
            if(style.GetIncludeChoiceList())
            {
                CGXControl *pControl = GetControl(nRow,nCol);
                pControl->GetControlText(strTipTextNew,nRow,nCol,strTipTextNew,style);
            }
            
            CRect rcCell = CalcRectFromRowCol(nRow,nCol,nRow,nCol);
            
            CClientDC dc(this);
            CSize szText = dc.GetTextExtent(strTipTextNew);
     
            //only show a tip if the text is longer than the cell
            if(szText.cx < rcCell.Width())
            {
                strTipTextNew.Empty();
            }
        }
        break;
        }
        
        if(strTipTextNew != m_strTipTextPrevious)
        {
            m_strTipTextPrevious = strTipTextNew;
            m_ctlToolTip.UpdateTipText(strTipTextNew,this);
        }
    */
    return CECGridCtrl::OnNcHitTest(point);
}

void CYRGridCtrl::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    CECGridCtrl::OnChar(nChar, nRepCnt, nFlags);
}
