/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_ENVIRONMENTPAGE_H__961AD3D3_D801_11D3_BD76_00C04F89E392__INCLUDED_)
#define AFX_ENVIRONMENTPAGE_H__961AD3D3_D801_11D3_BD76_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EnvironmentPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEnvironmentPage dialog
#include "GridCtrl.h"
#include "GenericListPage.h"

class CEnvironmentPage : public CGenericListPage
{
    DECLARE_DYNCREATE(CEnvironmentPage)

    typedef enum{enEnvironmentVariablesColumn=0};
    // Construction
public:
    CEnvironmentPage();
    ~CEnvironmentPage();

    // Dialog Data
    //{{AFX_DATA(CEnvironmentPage)
    enum { IDD = IDD_ENVIRONMENT_PAGE };
    //}}AFX_DATA


    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CEnvironmentPage)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CEnvironmentPage)
    afx_msg void OnSize(UINT nType, int cx, int cy);
    virtual BOOL OnInitDialog();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    afx_msg void OnInsertRow();
    afx_msg void OnDeleteRow();
    afx_msg LRESULT OnCanStartEditting(WPARAM,LPARAM);
    afx_msg LRESULT OnValidateCell(WPARAM,LPARAM);
    DECLARE_MESSAGE_MAP()

    //Get number of rows in list box
    int GetNumDataEntries();

    //get a row from the list box
    bool GetDataEntry(int nEntry,CStringArray& arstrParams);

    //Add a row to the list box
    void AddDataEntry(const CStringArray& arstrParams);
private:
    CString m_szHtmlHelpFile;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENVIRONMENTPAGE_H__961AD3D3_D801_11D3_BD76_00C04F89E392__INCLUDED_)
