/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_GENERICPAGE_H__68F0BB71_D888_11D3_BD76_00C04F89E392__INCLUDED_)
#define AFX_GENERICPAGE_H__68F0BB71_D888_11D3_BD76_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GenericPage.h : header file
//

#include "ListOutputDlg.h"
/////////////////////////////////////////////////////////////////////////////
// CGenericPage dialog
class CGenericPage : public CPropertyPage
{
    // Construction
public:
    typedef enum {enSQLQuery,enExecQuery,enNTPerformanceQuery,enSNMPQuery}QueryTypes;

    CGenericPage(UINT uiPage);
    ~CGenericPage();

    virtual int GetNumDataEntries()=0;
    virtual bool GetDataEntry(int nEntry,CStringArray& arstrParams)=0;
    virtual void AddDataEntry(const CStringArray& arstrParams)=0;

    const CString& GetTokenName()
    {
        return m_strTokenName;
    }

    BOOL EditQuery(QueryTypes nType,CString& strQuery);
protected:
    BOOL SpawnProcess(const CString& strCommandLine);

    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CGenericPage)
public:
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CGenericPage)
    virtual void OnOK();
    virtual void OnCancel();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    CString m_strTokenName;
    CGenericPage()
    {}


private:
    BOOL EditNTPerformanceQuery(CString& strQuery);
    BOOL EditText(CString &strQuery,const CString& strMessage);

    CListOutputDlg m_ListOutDlg;
};

///////////////////////////////////////////////////////////////////
class CEditTextDlg : public CDialog
{
public:
CEditTextDlg(CWnd* pParent = NULL):CDialog(IDD,pParent)
    {}   // standard constructor


    enum { IDD = IDD_EDIT_TEXT_DLG };
    CString m_strQuery;
    CString m_strMessage;

protected:
    virtual void DoDataExchange(CDataExchange* pDX)
    {
        CDialog::DoDataExchange(pDX);
        DDX_Text(pDX, IDC_QUERY_EDIT, m_strQuery);
        DDX_Text(pDX, IDC_MESSAGE, m_strMessage);
    }
    // Generated message map functions
    //{{AFX_MSG(CEditTextDlg)
    virtual BOOL OnInitDialog();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG

    DECLARE_MESSAGE_MAP()


private:
    CString m_szHtmlHelpFile;
};
/////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GENERICPAGE_H__68F0BB71_D888_11D3_BD76_00C04F89E392__INCLUDED_)
