// SNMPEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CSNMPEditDlg.h"
#include ".\CECSNMPQuery.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECSNMPEditDlg dialog


CECSNMPEditDlg::CECSNMPEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CECSNMPEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CECSNMPEditDlg)
	//}}AFX_DATA_INIT

	m_Query = "";
}


void CECSNMPEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CECSNMPEditDlg)
	DDX_Control(pDX, IDC_HOST_ADDR, m_ctlAddress);
	DDX_Control(pDX, IDC_WALK_LIST, m_ctlWalkList);
	DDX_Control(pDX, IDC_CATEGORY, m_ctlCategory);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CECSNMPEditDlg, CDialog)
	//{{AFX_MSG_MAP(CECSNMPEditDlg)
	ON_CBN_SELCHANGE(IDC_CATEGORY, OnSelchangeCategory)
	ON_CBN_SELCHANGE(IDC_HOST_ADDR, OnSelchangeHostAddr)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SCAN, OnScan)
	ON_CBN_KILLFOCUS(IDC_HOST_ADDR, OnKillfocusHostAddr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECSNMPEditDlg message handlers

BOOL CECSNMPEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_ctlCategory.InsertString(SYSTEM, "system");
	m_ctlCategory.InsertString(INTERFACES, "interfaces");
	m_ctlCategory.InsertString(AT, "at");
	m_ctlCategory.InsertString(IP, "ip");
	m_ctlCategory.InsertString(ICMP, "icmp");
	m_ctlCategory.InsertString(TCP, "tcp");
	m_ctlCategory.InsertString(UDP, "udp");
	m_ctlCategory.InsertString(EGP, "egp");
	m_ctlCategory.InsertString(DOT3, "dot3");
	m_ctlCategory.InsertString(SNMP, "snmp");
	m_ctlCategory.InsertString(MS_IIS, "Microsoft IIS");
	m_ctlCategory.SetCurSel(0);
	m_ctlCategory.EnableWindow(FALSE);

	CRect r;
	m_ctlWalkList.GetWindowRect(r);
	m_ctlWalkList.InsertColumn(0,"Query", LVCFMT_LEFT, r.Width()/2-2);
	m_ctlWalkList.InsertColumn(1,"Current Value", LVCFMT_LEFT, r.Width()/2-2);
	m_ctlWalkList.EnableWindow(FALSE);
	m_ctlWalkList.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_ctlAddress.SetFocus();


	if (m_Query != "")
	{
		CString strQ = m_Query;
		int nPos = strQ.Find(" ", 0);
		CString addr = strQ.Left(nPos);
		strQ = strQ.Right(strQ.GetLength() - nPos -1);

		nPos = strQ.Find(" ", 0);
		CString community = strQ.Left(nPos);
		strQ = strQ.Right(strQ.GetLength() - nPos -1);
		strQ.TrimRight();
		CString query = strQ;

		m_ctlAddress.SetWindowText(addr);
		m_ctlCategory.EnableWindow();
		m_ctlWalkList.EnableWindow();

		int cat = StringToCat(query);
		m_ctlCategory.SetCurSel(cat);
		WalkTable(cat);

		for(int i =0; i<m_ctlWalkList.GetItemCount(); i++)
		{
			if (m_ctlWalkList.GetItemText(i,0) == query)
			{
				m_ctlWalkList.SetFocus();
				m_ctlWalkList.SetItemState(i, LVIS_SELECTED|LVIS_DROPHILITED, LVIS_SELECTED);
			}
		}
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CECSNMPEditDlg::OnKillfocusHostAddr() 
{
	OnChangeIP();
}

void CECSNMPEditDlg::WalkTable(int nTable)
{
	CWaitCursor wc;
	m_ctlWalkList.DeleteAllItems();

	// Test for valid host and that an SNMP server is running
	CString strIP ="";
	int nPos = m_ctlAddress.GetCurSel();
	if (nPos != -1)
	{
		m_ctlAddress.GetLBText(nPos, strIP);
	}
	else
	{
		m_ctlAddress.GetWindowText(strIP);
	}

	if (strIP == "")
		return;

	try
	{
		CECSNMPQuery query;
		QUERY_DEF def;
		def.header = strIP;
		def.community = "public";
		def.server = strIP;
		def.nTimeout = 5000;
		def.query = CatToString(nTable);

		CStringArray results;
		if(query.ExecuteWalk(def, results))
		{
			for (int i =0; i<results.GetSize(); i++)
			{
				CString strRes = results.GetAt(i);
				int nPos = strRes.Find(" =",0);
				int nLen = strRes.GetLength();
				m_ctlWalkList.InsertItem(i,strRes.Left(nPos));
				m_ctlWalkList.SetItemText(i,1,strRes.Right(nLen-nPos-3));
			}
		}
	}
	catch (...)
	{
		m_ctlCategory.EnableWindow(FALSE);
		m_ctlWalkList.EnableWindow(FALSE);
		m_ctlWalkList.DeleteAllItems();
	}
}

void CECSNMPEditDlg::OnSelchangeCategory() 
{
	int nCat = m_ctlCategory.GetCurSel();
	WalkTable(nCat);
}

void CECSNMPEditDlg::OnOK() 
{
	// Get the selected query
	POSITION pos = m_ctlWalkList.GetFirstSelectedItemPosition();
	if (pos == NULL)
	{
		AfxMessageBox("Nothing Selected!!");
		return;
	}
	CWaitCursor wc;

	int nItem = m_ctlWalkList.GetNextSelectedItem(pos);
	CString strQuery = m_ctlWalkList.GetItemText(nItem,0);

	// Test query to see if it returns an integer value
	CString strIP ="";
	m_ctlAddress.GetWindowText(strIP);

	try
	{
		CECSNMPQuery query;
		QUERY_DEF def;
		def.header = strIP;
		def.community = "public";
		def.server = strIP;
		def.nTimeout = 5000;
		def.query = strQuery;


		if (query.ExecuteSimple(def) == -1)
		{
			return;
		}

		m_Query = strIP + " public "+ strQuery;
	}
	catch (...)
	{
		m_ctlCategory.EnableWindow(FALSE);
		m_ctlWalkList.EnableWindow(FALSE);
		m_ctlWalkList.DeleteAllItems();
	}
	CDialog::OnOK();
}

CString CECSNMPEditDlg::CatToString(int nCat)
{
	switch (nCat)
	{
		case SYSTEM:
		{
			return "system";
			break;
		}
		case INTERFACES:
		{
			return "interfaces";
			break;
		}
		case AT:
		{
			return "at";
			break;
		}
		case IP:
		{
			return "ip";
			break;
		}
		case ICMP:
		{
			return "icmp";
			break;
		}
		case TCP:
		{
			return "tcp";
			break;
		}
		case UDP:
		{
			return "udp";
			break;
		}
		case EGP:
		{
			return "egp";
			break;
		}
		case DOT3:
		{
			return "dot3";
			break;
		}
		case SNMP:
		{
			return "snmp";
			break;
		}
		case MS_IIS:
		{
			return "enterprises.microsoft.software.internetServer";
			break;
		}
	}
	return "";
}

CString CECSNMPEditDlg::GetSNMPQuery()
{
	return m_Query;
}

void CECSNMPEditDlg::SetQuery(CString query)
{
	m_Query = query;
}

int CECSNMPEditDlg::StringToCat(CString query)
{
	int nPos = query.Find("." , 0);

	if (query.Left(nPos) == "system")
	{
		return SYSTEM;
	}
	else if (query.Left(nPos) == "interfaces")
	{
		return INTERFACES;
	}
	else if (query.Left(nPos) == "at")
	{
		return AT;
	}
	else if (query.Left(nPos) == "ip")
	{
		return IP;
	}
	else if (query.Left(nPos) == "icmp")
	{
		return ICMP;
	}
	else if (query.Left(nPos) == "tcp")
	{
		return TCP;
	}
	else if (query.Left(nPos) == "udp")
	{
		return UDP;
	}
	else if (query.Left(nPos) == "egp")
	{
		return EGP;
	}
	else if (query.Left(nPos) == "dot3")
	{
		return DOT3;
	}
	else if (query.Left(nPos) == "snmp")
	{
		return SNMP;
	}
	else if (query.Left(45) == "enterprises.microsoft.software.internetServer")
	{
		return MS_IIS;
	}
	return -1;
}

void CECSNMPEditDlg::OnSelchangeHostAddr() 
{
	OnChangeIP();
}

void CECSNMPEditDlg::OnChangeIP()
{
	CWaitCursor wc;
	// Test for valid host and that an SNMP server is running
	CString strIP ="";
	int nPos = m_ctlAddress.GetCurSel();
	if (nPos != -1)
	{
		m_ctlAddress.GetLBText(nPos, strIP);
	}
	else
	{
		m_ctlAddress.GetWindowText(strIP);
	}

	if (strIP == "")
		return;

	try
	{
		CECSNMPQuery query;
		QUERY_DEF def;
		def.header = strIP;
		def.community = "public";
		def.server = strIP;
		def.query = "system.sysName.0";
		def.nTimeout = 5000;

		CString result;
		if (query.ExecuteDetailed(def, result))
		{
			// if running enable the other dlg controls and perform the current walk.
			m_ctlCategory.EnableWindow();
			m_ctlWalkList.EnableWindow();

			int nTable = m_ctlCategory.GetCurSel();
			WalkTable(nTable);

		}
		else
		{
			m_ctlCategory.EnableWindow(FALSE);
			m_ctlWalkList.EnableWindow(FALSE);
			// else inform user of invalid host.
			AfxMessageBox("Invalid Host!");
		}
	}
	catch(...)
	{
		m_ctlCategory.EnableWindow(FALSE);
		m_ctlWalkList.EnableWindow(FALSE);
		m_ctlWalkList.DeleteAllItems();
	}

}

void CECSNMPEditDlg::OnDestroy() 
{
	CDialog::OnDestroy();

}

void CECSNMPEditDlg::OnScan() 
{
	CWaitCursor wc;
	// Get this machine's ip address
	WORD      VersionRequested;
	WSADATA   stWSAData;

	VersionRequested = MAKEWORD(1, 1);
	WSAStartup(VersionRequested, &stWSAData);

    char hostname[256];
    gethostname(hostname,256);
    hostent* host=gethostbyname(hostname);
	CString strIP = "";
    if(host)
    {
        in_addr* addr;
        addr=((struct in_addr*)((host->h_addr_list)[0]));
		strIP = inet_ntoa(*addr);
    }

	WSACleanup();

	// strip off the final ip part
	int nPos = strIP.ReverseFind('.');
	strIP = strIP.Left(nPos);

	try
	{
		// Clear the combo box
		m_ctlAddress.ResetContent();

		// Scan all net addresses on the local subnet
		for (int i =0; i<=255; i++)
		{
			CString addr;
			addr.Format("%s.%d", strIP, i);
			QUERY_DEF def;
			def.community = "public";
			def.server = addr;
			def.query = "system.sysName.0";
			def.nTimeout = 5000;
		
			CECSNMPQuery query;
			CString result;

			// if the query is sucessful add the ip address to the combo
			if(query.ExecuteDetailed(def, result))
			{
				m_ctlAddress.AddString(addr);
			}

		}

	}
	catch (...)
	{
		m_ctlCategory.EnableWindow(FALSE);
		m_ctlWalkList.EnableWindow(FALSE);
		m_ctlWalkList.DeleteAllItems();
	}

	// Select the first ip address in the list and perform initial category walk.
	m_ctlAddress.SetCurSel(0);
	OnChangeIP();
}
