/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

////////////////////////////////////////////////////////////////////////////////
// @doc     Document
// @module  CECProjectSelector | Project Selection Dialog
//
////////////////////////////////////////////////////////////////////////////////


#if !defined(AFX_CECPROJECTSELECTOR_H__8E709F78_F8A3_11D2_BDC5_00608CB45114__INCLUDED_)
#define AFX_CECPROJECTSELECTOR_H__8E709F78_F8A3_11D2_BDC5_00608CB45114__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECProjectSelector.h : header file
//
#define WMU_PROJECT_CHANGED     (WM_USER+7000)
/////////////////////////////////////////////////////////////////////////////
// CECProjectSelector dialog
class CYRServer;
class CECProjectSelector : public CDialog
{
    // Construction
public:
    void SetProjectType(CString projType);
    int m_nOldSel;
    CString GetProjectName();
    CECProjectSelector(CWnd* pParent = NULL);   // standard constructor
    void SetProjectName(CString ProjectName);
    void SetServer(CYRServer* pServer);
    // Dialog Data
    //{{AFX_DATA(CECProjectSelector)
    enum { IDD = IDD_PROJ_SELECT };
    // NOTE: the ClassWizard will add data members here
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECProjectSelector)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CECProjectSelector)
    virtual BOOL OnInitDialog();
    afx_msg void OnDropdownProjCombo();
    afx_msg void OnCloseupProjCombo();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
private:
    CString m_strType;
    CYRServer* m_pServer;
    CString m_ProjectName;
    void GetListOfProjects();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECPROJECTSELECTOR_H__8E709F78_F8A3_11D2_BDC5_00608CB45114__INCLUDED_)
