#if !defined(AFX_XRESULTSCTL_H__502A94D4_CD97_11D3_9A95_00500447FC27__INCLUDED_)
#define AFX_XRESULTSCTL_H__502A94D4_CD97_11D3_9A95_00500447FC27__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XResultsCtl.h : Declaration of the CXResultsCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CXResultsCtrl : See XResultsCtl.cpp for implementation.
#include "CECResultsDlg.h"
class CYRServer;

class CXResultsCtrl : public COleControl
{
    DECLARE_DYNCREATE(CXResultsCtrl)

    // Constructor
public:
    CXResultsCtrl();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXResultsCtrl)
public:
    virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
    virtual void DoPropExchange(CPropExchange* pPX);
    virtual void OnResetState();
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    //}}AFX_VIRTUAL

    // Implementation
protected:
    ~CXResultsCtrl();

    DECLARE_OLECREATE_EX(CXResultsCtrl)    // Class factory and guid
    DECLARE_OLETYPELIB(CXResultsCtrl)      // GetTypeInfo
    DECLARE_PROPPAGEIDS(CXResultsCtrl)     // Property page IDs
    DECLARE_OLECTLTYPE(CXResultsCtrl)       // Type name and misc status

    // Message maps
    //{{AFX_MSG(CXResultsCtrl)
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    //}}AFX_MSG
    afx_msg LRESULT OnUpdateTitle(WPARAM,LPARAM);
    DECLARE_MESSAGE_MAP()

    // Dispatch maps
    //{{AFX_DISPATCH(CXResultsCtrl)
    afx_msg void XSetServerInfo(LPCTSTR Username, LPCTSTR Password);
    afx_msg void XInitialize(LPCTSTR ProjectName, LPCTSTR TestName, LPCTSTR RunName, short nType);
    //}}AFX_DISPATCH
    DECLARE_DISPATCH_MAP()

    afx_msg void AboutBox();

    // Event maps
    //{{AFX_EVENT(CXResultsCtrl)
    void FireXUpdateTitle(LPCTSTR strTestName, LPCTSTR strRunName, short nType)
    {
        FireEvent(eventidXUpdateTitle,EVENT_PARAM(VTS_BSTR VTS_BSTR VTS_I2), strTestName, strRunName, nType);
    }
    //}}AFX_EVENT
    DECLARE_EVENT_MAP()

    // Dispatch and event IDs
public:
    enum {
        //{{AFX_DISP_ID(CXResultsCtrl)
        dispidXSetServerInfo = 1L,
        dispidXInitialize = 2L,
        eventidXUpdateTitle = 1L,
        //}}AFX_DISP_ID
    };

private:
    // @cmember The server object
    CYRServer*  m_pServer;

    // @cmember Password to log on to the server with
    CString         m_Password;

    // @cmember Username to log onto the server with
    CString         m_Username;

    // @cmember The actual result viewer dialog.
    CECResultsDlg m_Results;

    // @cmember Connect to the server
    BOOL            IsServerRunning();

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XRESULTSCTL_H__502A94D4_CD97_11D3_9A95_00500447FC27__INCLUDED)
