/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECGraphControl.cpp : implementation file
//

#include "stdafx.h"
#include "XTestDynamicGraphs.h"
#include "CECGraphControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECGraphControl

CECGraphControl::CECGraphControl()
{
}


CECGraphControl::~CECGraphControl()
{}



BEGIN_MESSAGE_MAP(CECGraphControl, CStatic)
//{{AFX_MSG_MAP(CECGraphControl)
ON_WM_PAINT()
ON_WM_ERASEBKGND()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECGraphControl message handlers

void CECGraphControl::OnPaint()
{
    CPaintDC dc(this); // device context for painting

    // The Objective Chart object takes over the paint process from here
    m_Graph.DrawComponentList(&dc,this);

    CRect rcClient;
    GetClientRect(&rcClient);

    CBrush brBackgnd(GetSysColor(COLOR_BTNFACE));
    CBrush *pOldBrush = dc.SelectObject(&brBackgnd);
    CPen penDkGray(PS_SOLID,1,RGB(0,0,0));

    POSITION pos = m_Graph.GetFirstComponentPosition(IDS_SRG_DISPLAYTYPE);
    while(pos != NULL)
    {
        SRGraphDisplay* pD = (SRGraphDisplay*)m_Graph.GetNextComponent(pos,IDS_SRG_DISPLAYTYPE);

        //Don't draw last line
        if(pos == NULL)
            break;

        CRect rc = pD->GetDisplayRect();

        rc.left = -1;
        rc.right = rcClient.right+1;
        rc.top = rc.bottom + 10 ;
        rc.bottom = rc.top + 4;

        dc.SelectStockObject(NULL_PEN);
        dc.Rectangle(rc);

        dc.SelectStockObject(WHITE_PEN);
        dc.MoveTo(-1,rc.bottom-1);
        dc.LineTo(rc.right-1,rc.bottom-1);
        dc.LineTo(rc.right-1,rc.top);

        CPen *pOldPen = dc.SelectObject(&penDkGray);
        dc.LineTo(-1,rc.top);
        dc.LineTo(-1,rc.bottom-2);
        dc.SelectObject(pOldPen);
    }
    dc.SelectObject(pOldBrush);

    // Do not call CStatic::OnPaint() for painting messages
}


BOOL CECGraphControl::OnEraseBkgnd(CDC* pDC)
{
    return true;
}

