/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef __Diagnostics_hh__
#define __Diagnostics_hh__

#ifndef USE_omniORB_logStream
#define USE_omniORB_logStream
#endif

#ifndef __CORBA_H_EXTERNAL_GUARD__
#define __CORBA_H_EXTERNAL_GUARD__
#include <omniORB2/CORBA.h>
#endif

#ifdef _LC_attr
# error "A local CPP macro _LC_attr has already been defined."
#else
# ifdef  USE_stub_in_nt_dll
#  define _LC_attr _OMNIORB_NTDLL_IMPORT
# else
#  define _LC_attr
# endif
#endif

#ifndef __Diagnostics__
#define __Diagnostics__
class   Diagnostics;
typedef Diagnostics* Diagnostics_ptr;
typedef Diagnostics_ptr DiagnosticsRef;

class Diagnostics_Helper
{
public:
    static Diagnostics_ptr _nil();
    static CORBA::Boolean is_nil(Diagnostics_ptr p);
    static void release(Diagnostics_ptr p);
    static void duplicate(Diagnostics_ptr p);
    static size_t NP_alignedSize(Diagnostics_ptr obj,size_t initialoffset);
    static void marshalObjRef(Diagnostics_ptr obj,NetBufferedStream &s);
    static Diagnostics_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(Diagnostics_ptr obj,MemBufferedStream &s);
    static Diagnostics_ptr unmarshalObjRef(MemBufferedStream &s);
};
typedef _CORBA_ObjRef_Var<Diagnostics,Diagnostics_Helper> Diagnostics_var;

#endif
#define Diagnostics_IntfRepoID "IDL:Diagnostics:1.0"

class Diagnostics : public virtual omniObject, public virtual CORBA::Object
{
public:

    typedef Diagnostics_ptr _ptr_type;
    typedef Diagnostics_var _var_type;
    static _LC_attr const char * CLASS_NAME;
    virtual CORBA::Long  AddClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class, CORBA::Long  Level) = 0;
    virtual CORBA::Long  DeleteClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class) = 0;
    virtual CORBA::Long  DeleteAllClasses(const char*  Executable, const char*  User, const char*  Node) = 0;
    virtual CORBA::Long  IsTraced(const char*  Executable, const char*  User, const char*  Node) = 0;
    virtual CORBA::Long  _0RL__GetClasses(const char*  Executable, const char*  User, const char*  Node, char* & Buff, CORBA::ULong  BufLen, char* & LevelBuf, CORBA::ULong  LevelBufLen) = 0;
    CORBA::Long  GetClasses ( const char *  Executable,
                              const char *  User,
                              const char *  Node,
                              CORBA::String_OUT_arg  Buff,
                              CORBA::ULong  BufLen,
                              CORBA::String_OUT_arg  LevelBuf,
                              CORBA::ULong  LevelBufLen )
    {
        return _0RL__GetClasses ( Executable, User, Node, Buff._data, BufLen, LevelBuf._data, LevelBufLen );
    }
    static Diagnostics_ptr _duplicate(Diagnostics_ptr);
    static Diagnostics_ptr _narrow(CORBA::Object_ptr);
    static Diagnostics_ptr _nil();

    static inline size_t NP_alignedSize(Diagnostics_ptr obj,size_t initialoffset)
    {
        return CORBA::AlignedObjRef(obj,Diagnostics_IntfRepoID,20,initialoffset);
    }

    static inline void marshalObjRef(Diagnostics_ptr obj,NetBufferedStream &s)
    {
        CORBA::MarshalObjRef(obj,Diagnostics_IntfRepoID,20,s);
    }

    static inline Diagnostics_ptr unmarshalObjRef(NetBufferedStream &s)
    {
        CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(Diagnostics_IntfRepoID,s);
        Diagnostics_ptr _result = Diagnostics::_narrow(_obj);
        CORBA::release(_obj);
        return _result;
    }

    static inline void marshalObjRef(Diagnostics_ptr obj,MemBufferedStream &s)
    {
        CORBA::MarshalObjRef(obj,Diagnostics_IntfRepoID,20,s);
    }

    static inline Diagnostics_ptr unmarshalObjRef(MemBufferedStream &s)
    {
        CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(Diagnostics_IntfRepoID,s);
        Diagnostics_ptr _result = Diagnostics::_narrow(_obj);
        CORBA::release(_obj);
        return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

protected:

    Diagnostics()
    {
        if (!is_proxy())
            omniObject::PR_IRRepositoryId(Diagnostics_IntfRepoID);
        this->PR_setobj(this);
    }
    virtual ~Diagnostics()
{}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

private:

    Diagnostics(const Diagnostics&);
    Diagnostics &operator=(const Diagnostics&);
};

class _sk_Diagnostics :  public virtual Diagnostics
{
public:

    _sk_Diagnostics()
    {}

    _sk_Diagnostics(const omniORB::objectKey& k);
    virtual ~_sk_Diagnostics()
    {}

    Diagnostics_ptr _this()
    {
        return Diagnostics::_duplicate(this);
    }
    void _obj_is_ready(CORBA::BOA_ptr boa)
    {
        boa->obj_is_ready(this);
    }
    CORBA::BOA_ptr _boa()
    {
        return CORBA::BOA::getBOA();
    }
    void _dispose()
    {
        _boa()->dispose(this);
    }
    omniORB::objectKey _key();
    virtual CORBA::Long  AddClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class, CORBA::Long  Level) = 0;
    virtual CORBA::Long  DeleteClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class) = 0;
    virtual CORBA::Long  DeleteAllClasses(const char*  Executable, const char*  User, const char*  Node) = 0;
    virtual CORBA::Long  IsTraced(const char*  Executable, const char*  User, const char*  Node) = 0;
    virtual CORBA::Long  GetClasses(const char*  Executable, const char*  User, const char*  Node, char* & Buff, CORBA::ULong  BufLen, char* & LevelBuf, CORBA::ULong  LevelBufLen) = 0;
    virtual CORBA::Long  _0RL__GetClasses(const char*  Executable, const char*  User, const char*  Node, char* & Buff, CORBA::ULong  BufLen, char* & LevelBuf, CORBA::ULong  LevelBufLen)
    {
        return GetClasses(Executable, User, Node, Buff, BufLen, LevelBuf, LevelBufLen);
    }
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id)
    {
        return Diagnostics::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
private:
    _sk_Diagnostics (const _sk_Diagnostics&);
    _sk_Diagnostics &operator=(const _sk_Diagnostics&);
};

class _proxy_Diagnostics :  public virtual Diagnostics
{
public:

_proxy_Diagnostics (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
    omniObject(Diagnostics_IntfRepoID,r,key,keysize,profiles,release)
    {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_Diagnostics()
    {}

    virtual CORBA::Long  AddClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class, CORBA::Long  Level);
    virtual CORBA::Long  DeleteClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class);
    virtual CORBA::Long  DeleteAllClasses(const char*  Executable, const char*  User, const char*  Node);
    virtual CORBA::Long  IsTraced(const char*  Executable, const char*  User, const char*  Node);
    virtual CORBA::Long  _0RL__GetClasses(const char*  Executable, const char*  User, const char*  Node, char* & Buff, CORBA::ULong  BufLen, char* & LevelBuf, CORBA::ULong  LevelBufLen);

protected:

    _proxy_Diagnostics ()
    {}


    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type)
    {
        return Diagnostics::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
private:

    _proxy_Diagnostics (const _proxy_Diagnostics&);
    _proxy_Diagnostics &operator=(const _proxy_Diagnostics&);
};

class _nil_Diagnostics : public virtual Diagnostics
{
public:
_nil_Diagnostics() : omniObject(omniObject::nilObjectManager())
    {
        this->PR_setobj(0);
    }
    virtual ~_nil_Diagnostics()
    {}

    CORBA::Long  AddClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class, CORBA::Long  Level)
    {
        throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
        // never reach here! Dummy return to keep some compilers happy.
        CORBA::Long _0RL_result = 0;
        return _0RL_result;
#endif
    }

    CORBA::Long  DeleteClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class)
    {
        throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
        // never reach here! Dummy return to keep some compilers happy.
        CORBA::Long _0RL_result = 0;
        return _0RL_result;
#endif
    }

    CORBA::Long  DeleteAllClasses(const char*  Executable, const char*  User, const char*  Node)
    {
        throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
        // never reach here! Dummy return to keep some compilers happy.
        CORBA::Long _0RL_result = 0;
        return _0RL_result;
#endif
    }

    CORBA::Long  IsTraced(const char*  Executable, const char*  User, const char*  Node)
    {
        throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
        // never reach here! Dummy return to keep some compilers happy.
        CORBA::Long _0RL_result = 0;
        return _0RL_result;
#endif
    }

    CORBA::Long  _0RL__GetClasses(const char*  Executable, const char*  User, const char*  Node, char* & Buff, CORBA::ULong  BufLen, char* & LevelBuf, CORBA::ULong  LevelBufLen)
    {
        throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
        // never reach here! Dummy return to keep some compilers happy.
        CORBA::Long _0RL_result = 0;
        return _0RL_result;
#endif
    }

protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id)
    {
        return Diagnostics::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
};

class Diagnostics_proxyObjectFactory : public proxyObjectFactory
{
public:
    Diagnostics_proxyObjectFactory ()
    {}

    virtual ~Diagnostics_proxyObjectFactory ()
    {}

    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static Diagnostics_ptr _nil()
    {
        if (!__nil_Diagnostics)
        {
            __nil_Diagnostics = new _nil_Diagnostics;
        }
        return __nil_Diagnostics;
    }
private:
    static Diagnostics_ptr __nil_Diagnostics;
};


#undef _LC_attr

#endif // __Diagnostics_hh__
