#ifndef __ENUMDATA_H__
#define __ENUMDATA_H__
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#include "ipaddr.h"

struct _TSyntaxColor
{
    COLORREF    m_crKeywordsColor ;
    COLORREF    m_crQuoteColor ;
    COLORREF    m_crCommentColor ;
    COLORREF    m_crTextColor ;
    COLORREF    m_crBackGroundColor ;
    BOOL        m_bChroma ;
} ;

struct _TIndentation
{
    int         m_nTabSize ;
    BOOL        m_bShowTab ;
    BOOL        m_bInsertSpaces ;
} ;

struct _TFont
{
    LOGFONT*    m_pFont ;
    int         m_nSize ;
} ;

struct _TPreferencesGenericData
{
    _TSyntaxColor       m_SyntaxColor ;
    _TIndentation       m_Indentation ;
    _TFont              m_Font ;
};

struct _TPreferencesProxyData
{
    CString         m_strProxyAddress;
    long            m_lAddressPort;
    CString         m_strProxySecure;
    long            m_lSecurePort;
    BOOL            m_bByPassProxyLocal;
    CString         m_strAddressesNoProxy;
} ;

struct _TProxyData
{
    _TPreferencesProxyData  m_LocalProxy ;
    _TPreferencesProxyData  m_RemoteProxy ;
} ;

struct _TPreferencesGatewayData
{
    long            m_lAdministrationPort;
    long            m_lListenPort;
    BOOL            m_bLocal ;
    _TProxyData     m_ProxyInfo ;
} ;


struct _TPreferencesGeneralData
{
    CString         m_strPrefixe ;
    BOOL            m_bConsole ;
    BOOL            m_bTrace ;

} ;

struct _TPreferencesRepositoryData
{
    CString         m_strLocalDirectory ;
    CString         m_strServerAddress  ;
    long            m_lServerPort       ;
} ;

#endif
