/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ColSplitter.cpp: implementation of the CColSplitter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ColSplitter.h"

//--------------------------------------------------------------------

BEGIN_MESSAGE_MAP(CColSplitter, CSplitterWnd)
//{{AFX_MSG_MAP(CColSplitter)
ON_WM_SIZE()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//--------------------------------------------------------------------

CColSplitter::CColSplitter()
{
    m_cxFirstCol    = 0;
    m_cxSecondCol   = 0;
}

//--------------------------------------------------------------------

CColSplitter::~CColSplitter()
{
}

//--------------------------------------------------------------------


void CColSplitter::OnSize(UINT nType, int cx, int cy)
{
    if ( m_pColInfo == NULL )
    {
        CSplitterWnd::OnSize(nType, cx, cy);
        return;
    }

    if ( cx < m_cxSecondCol)
    {
        SetColumnInfo(0,0,0);
        SetColumnInfo(1,cx,0);
    }
    else
    {
        SetColumnInfo(0,cx - m_cxSecondCol,0);
        SetColumnInfo(1,m_cxSecondCol,0);
    }
    CSplitterWnd::OnSize(nType, cx, cy);
}

//--------------------------------------------------------------------

void CColSplitter::SetColumnsSize(int _cxFirstCol, int _cxSecondCol)
{
    m_cxFirstCol    = _cxFirstCol;
    m_cxSecondCol   = _cxSecondCol;
}

//--------------------------------------------------------------------

void CColSplitter::TrackColumnSize(int x, int col)
{
    CRect rc;
    GetClientRect(rc);

    m_cxFirstCol    = x;
    m_cxSecondCol   = ( ( rc.Width()-x ) > 0 ? (rc.Width()-x) : 0 );

    CSplitterWnd::TrackColumnSize(x, col);

}
