/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#include "stdafx.h"
#include "RootDocument.h"
#include "StubDocument.h"
#include "ExtendedMultiDocTemplate.h"


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(CExtendedMultiDocTemplate,CMultiDocTemplate)

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CExtendedMultiDocTemplate::CExtendedMultiDocTemplate( UINT            nIDResource ,
        CRuntimeClass * pDocClass ,
        CRuntimeClass * pFrameClass ,
        CRuntimeClass * pViewClass )
        :  CMultiDocTemplate( nIDResource , pDocClass , pFrameClass , pViewClass ) ,
        m_pRootDoc(NULL)
{
    ASSERT( pDocClass->IsDerivedFrom( RUNTIME_CLASS(CStubDocument) ));
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CRootDocument * CExtendedMultiDocTemplate::SetRootDocument( CRootDocument * pDoc )
{
    CRootDocument * pPrevRootDoc = m_pRootDoc ;

    ASSERT( pDoc == NULL || pDoc->IsKindOf(RUNTIME_CLASS(CRootDocument)) ) ;
    //ASSERT( m_pRootDoc == NULL || pDoc == NULL ) ; // For safety's sake, so as to avoid cross-document*/


    m_pRootDoc = pDoc ;                            // problems 'm_pRootDoc' must be reset to NULL
    // immediately after use.
    return pPrevRootDoc ;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CRootDocument * CExtendedMultiDocTemplate::GetRootDocument() const
{
    return m_pRootDoc ;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CDocument * CExtendedMultiDocTemplate::CreateNewDocument()
{
    CDocument * pDoc = CMultiDocTemplate::CreateNewDocument() ;
    // ----
    ASSERT( pDoc != NULL ) ;
    ASSERT( pDoc->IsKindOf(RUNTIME_CLASS(CStubDocument)) ) ;
    ASSERT( GetRootDocument() != NULL ) ;

    if ( m_pRootDoc != NULL )
    {
        static_cast<CStubDocument *>(pDoc)->SetRootDocument( GetRootDocument() ) ;
    }

    return pDoc ;
}



