/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// MenuParam.cpp: implementation of the CMenuParam class.
//
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "MenuParam.h"

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
CMenuParam::CMenuParam( UINT nMenuID, UINT nSubMenuIndex )
        :  m_nMenuID(nMenuID) ,
        m_nSubMenuIndex(nSubMenuIndex)
{}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CMenuParam::~CMenuParam()
{}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CMenuParam::SetMenuParam( UINT nMenuID , UINT nSubMenuIndex )
{
    m_nMenuID       = nMenuID ;
    m_nSubMenuIndex = nSubMenuIndex ;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void CMenuParam::GetMenuParam( UINT & nMenuID , UINT & nSubMenuIndex ) const
{
    nMenuID       = m_nMenuID ;
    nSubMenuIndex = m_nSubMenuIndex ;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
UINT CMenuParam::GetMenuID() const
{
    return m_nMenuID ;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
UINT CMenuParam::GetSubMenuIndex() const
{
    return m_nSubMenuIndex ;
}
