/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CG: This file was added by the Splash Screen component.

#ifndef _SPLASH_SCRN_
#define _SPLASH_SCRN_

// Splash.h : header file
//

/////////////////////////////////////////////////////////////////////////////
//   Splash Screen class

class CSplashWnd : public CWnd
{
    // Construction
    //timer : time of splash display
    UINT        m_nTime ;

protected:
    CSplashWnd();

    // Attributes:
public:
    CBitmap m_bitmap;

    // Operations
public:

    // enable or not to show the splash
    static BOOL IsVisible();
    // enable or not to show the splash
    static void EnableSplashScreen(BOOL bEnable = TRUE);
    // display the splash
    static void ShowSplashScreen(CWnd* pParentWnd = NULL , UINT nID = 0 , UINT nTime =0 );
    //intercept messages, treat them and transfer them to the App if necessary
    static BOOL PreTranslateAppMessage(MSG* pMsg);

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CSplashWnd)
    //}}AFX_VIRTUAL

    // Implementation
public:
    ~CSplashWnd();
    virtual void PostNcDestroy();

protected:
    //create splash
    BOOL Create(CWnd* pParentWnd = NULL , UINT nID = 0 , UINT nTime = 0 );
    //hide splash
    void HideSplashScreen();

    static BOOL c_bShowSplashWnd;
    static CSplashWnd* c_pSplashWnd;

    // Generated message map functions
protected:
    //{{AFX_MSG(CSplashWnd)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnPaint();
    afx_msg void OnTimer(UINT nIDEvent);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};


#endif
