/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// OSGridCtrl.h: interface for the COSGridCtrl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OSGRIDCTRL_H__09230D34_7395_11D4_AFE2_0001026CF1C0__INCLUDED_)
#define AFX_OSGRIDCTRL_H__09230D34_7395_11D4_AFE2_0001026CF1C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CECGridCtrl.h"

class COSGridCtrl : public CECGridCtrl
{

public:
    COSGridCtrl();
    virtual ~COSGridCtrl();

    BOOL Create( CWnd * pParent , UINT   nAreaID,
                 UINT   nGridCtrlID, int nHiddenCols = 0 );
    BOOL Create( const RECT& rect, CWnd* parent, UINT nID,
                 DWORD dwStyle = WS_CHILD | WS_BORDER | WS_TABSTOP | WS_VISIBLE );

    virtual BOOL SetValueRowCol( int nRow, int nCol, CString strValue );
    virtual void GetValueRowCol( int nRow, int nCol, CString & strValue );

    void SetLastDataRow( int nRow )
    {
        m_nLastDataRow = nRow;
    }
    int  GetLastDataRow()
    {
        return m_nLastDataRow;
    }

    BOOL GetFirstSelectedRow( int & nRow );     // -1 if no selected row
    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(COSGridCtrl)
    //}}AFX_VIRTUAL

    DECLARE_MESSAGE_MAP()
private:
    int m_nLastDataRow;
    // Generated message map functions
protected:
    //{{AFX_MSG(COSGridCtrl)
    //}}AFX_MSG

}
;

#endif // !defined(AFX_OSGRIDCTRL_H__09230D34_7395_11D4_AFE2_0001026CF1C0__INCLUDED_)
