/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// VarAddrNameDlg.cpp : implementation file
//

#include "stdafx.h"
#include "modeller.h"
#include "VarAddrNameDlg.h"
#include "htmlhelp.h"
#include "Help\VarAddrNameDlg.inl"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVarAddrNameDlg dialog
//----------------------------------------------------------------------------

BEGIN_MESSAGE_MAP(CVarAddrNameDlg, CDialog)
//{{AFX_MSG_MAP(CVarAddrNameDlg)
ON_WM_CTLCOLOR()
ON_WM_HELPINFO()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//----------------------------------------------------------------------------

CVarAddrNameDlg::CVarAddrNameDlg( CVarResponse *_pVarResponse /*= NULL*/, CWnd* pParent /*=NULL*/)
        : CDialog(CVarAddrNameDlg::IDD, pParent),
        m_pVarResponse( _pVarResponse )
{
    //{{AFX_DATA_INIT(CVarAddrNameDlg)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}

//----------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
// CVarAddrNameDlg message handlers
//----------------------------------------------------------------------------


void CVarAddrNameDlg::Ctrl2Values()
{
    GetDlgItem( ID_VAR_NAME_EDIT )->GetWindowText( m_pVarResponse->m_strVarName ) ;
}

//----------------------------------------------------------------------------

void CVarAddrNameDlg::OnOK()
{
	CString str;
	GetDlgItem( ID_VAR_NAME_EDIT )->GetWindowText(str);
	if(str.IsEmpty())
	{
		AfxMessageBox("Please enter a name for the variable");
		return;
	}

    Ctrl2Values() ;

    CDialog::OnOK() ;
}

//----------------------------------------------------------------------------

HBRUSH CVarAddrNameDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
    HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

    if( nCtlColor == CTLCOLOR_STATIC && pWnd->m_hWnd == GetDlgItem( IDC_TITLE_STATIC )->m_hWnd )
    {
        pDC->SetTextColor( RGB( 0 , 0 , 255 ) ) ;
    }

    return hbr;
}

//----------------------------------------------------------------------------

BOOL CVarAddrNameDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    GetDlgItem( ID_VAR_NAME_EDIT )->SetFocus() ;

    return FALSE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


BOOL CVarAddrNameDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp;
    contextHelp.LoadString(IDS_MODELLER_HELP_FILE);
    contextHelp= getenv("CYRANO_HOME")+contextHelp+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}
