#if !defined(AFX_VARDBCOLSELPPAGE_H__C74DBA53_DA24_11D3_930D_00104B4B2995__INCLUDED_)
#define AFX_VARDBCOLSELPPAGE_H__C74DBA53_DA24_11D3_930D_00104B4B2995__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// VarDBColSelPPage.h : header file
//
#include <ExtendedPropertyPage.h>
#include <ExtendedComboBox.h>
#include "VarDBTableList.h"
#include "VarDBColumnList.h"
#include "resource.h"
#include <VarStructures.h>


/////////////////////////////////////////////////////////////////////////////
// CVarDBColSelPPage dialog

class CVarDBColSelPPage : public CExtendedPropertyPage
{
    DECLARE_DYNCREATE(CVarDBColSelPPage)

    //Attribute
private:
    CListCtrl   m_TableList, m_ColumnList ;
    CExtendedComboBox   m_OwnerList ;

    CVarDBTableList     m_DBTableList ;
    CVarDBColumnList    m_DBColumnList ;

    // Construction
public:
    CVarDBColSelPPage(CVarDBParam * _VarDBParam = NULL) ;
    ~CVarDBColSelPPage() ;

    virtual void Ctrl2Values() ;
    virtual void Values2Ctrl() ;

    void ShowColumns(int _nRow);
    void FillColumnList();
    void ShowTables(int _nOwnerId);

    // Dialog Data
    //{{AFX_DATA(CVarDBColSelPPage)
    enum { IDD = IDD_VAR_DBCOLSEL_PPAGE };
    //}}AFX_DATA


    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CVarDBColSelPPage)
public:
    virtual LRESULT OnWizardBack();
    virtual LRESULT OnWizardNext();
    virtual BOOL OnSetActive();
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CVarDBColSelPPage)
    virtual BOOL OnInitDialog();
    afx_msg void OnItemchangedTableList(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
    afx_msg void OnSelchangeOwnerCombo();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    CVarDBParam *   m_pVarDBParam ;
    BOOL            m_bComingFromBack ;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VARDBCOLSELPPAGE_H__C74DBA53_DA24_11D3_930D_00104B4B2995__INCLUDED_)
