/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// VariableOptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "modeller.h"
#include "VariableOptionDlg.h"
#include "htmlhelp.h"
#include "Help\VariableOptionDlg.inl"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVariableOptionDlg dialog


CVariableOptionDlg::CVariableOptionDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CVariableOptionDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CVariableOptionDlg)
    m_strPrefix = _T("");
    //}}AFX_DATA_INIT
}



void CVariableOptionDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CVariableOptionDlg)
    DDX_Text(pDX, IDC_PREFIX, m_strPrefix);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CVariableOptionDlg, CDialog)
//{{AFX_MSG_MAP(CVariableOptionDlg)
ON_WM_HELPINFO()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVariableOptionDlg message handlers

void CVariableOptionDlg::OnOK()
{
    UpdateData(TRUE);
    CDialog::OnOK();
}

BOOL CVariableOptionDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    UpdateData(FALSE);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


BOOL CVariableOptionDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp;
    contextHelp.LoadString(IDS_MODELLER_HELP_FILE);
    contextHelp= getenv("CYRANO_HOME")+contextHelp+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}
