/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECCommanderView.h : interface of the CECCommanderView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECCOMMANDERVIEW_H__FF67E810_67AF_11D4_A6DA_00500447FC27__INCLUDED_)
#define AFX_CECCOMMANDERVIEW_H__FF67E810_67AF_11D4_A6DA_00500447FC27__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CECCommanderView : public CView
{
protected: // create from serialization only
    CECCommanderView();
    DECLARE_DYNCREATE(CECCommanderView)

    // Attributes
public:
    CECCommanderDoc* GetDocument();

    // Operations
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECCommanderView)
public:
    virtual void OnDraw(CDC* pDC);  // overridden to draw this view
    virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
    virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
    virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
    virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CECCommanderView();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:

    // Generated message map functions
protected:
    //{{AFX_MSG(CECCommanderView)
    // NOTE - the ClassWizard will add and remove member functions here.
    //    DO NOT EDIT what you see in these blocks of generated code !
    //}}AFX_MSG
    afx_msg void OnContextMenu(CWnd*, CPoint point);
    afx_msg void OnFilePrintPreview();
    DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in CECCommanderView.cpp
inline CECCommanderDoc* CECCommanderView::GetDocument()
{
    return (CECCommanderDoc*)m_pDocument;
}
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECCOMMANDERVIEW_H__FF67E810_67AF_11D4_A6DA_00500447FC27__INCLUDED_)
