/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CECGlobalCmdTarget.h
// --------------------
//
//    This is the include file for the CECGlobalCmdTarget class
//
//=========================================================================

#if !defined CECGlobalCmdTarget_INCLUDED
#define CECGlobalCmdTarget_INCLUDED

#include "CECPluginFrame.h"

class CECGlobalCmdTarget : public CECPluginFrame
{
protected:
    DECLARE_DYNAMIC(CECGlobalCmdTarget);

    CECGlobalCmdTarget();

    // Destructor
    virtual ~CECGlobalCmdTarget();

    //{{AFX_MSG(CECGlobalCmdTarget)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()

public:

    //{{AFX_VIRTUAL(CECGlobalCmdTarget)
public:
    virtual void ActivateFrame(int nCmdShow = -1);
    //}}AFX_VIRTUAL

    afx_msg LRESULT OnFireGlobalEvent (WPARAM,LPARAM);
    afx_msg LRESULT OnFireSpecificEvent (WPARAM,LPARAM);
    afx_msg LRESULT OnSetOutputWindow   (WPARAM,LPARAM);
    afx_msg LRESULT OnSetProject (WPARAM,LPARAM);
    afx_msg LRESULT OnSetStatusBarText  (WPARAM,LPARAM);
    afx_msg LRESULT OnGetUserKey (WPARAM,LPARAM);
    afx_msg LRESULT OnGetInstallDir (WPARAM,LPARAM);
    afx_msg LRESULT OnGetKnownExtensions    (WPARAM,LPARAM);
    afx_msg LRESULT OnGetServerPtr (WPARAM,LPARAM);
    afx_msg LRESULT OnGetProductType    (WPARAM,LPARAM);
    afx_msg LRESULT OnGetProductPrefix(WPARAM,LPARAM);
    afx_msg LRESULT OnBeginWait(WPARAM,LPARAM);
    afx_msg LRESULT OnEndWait(WPARAM,LPARAM);
    afx_msg LRESULT OnWizardStart(WPARAM,LPARAM);

};

#endif
