/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECCyranoHome.cpp: implementation of the CECCyranoHome class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CECCyranoHome.h"

#define CYRANO_HOME "CYRANO_HOME"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CECCyranoHome::CECCyranoHome()
{
}


CECCyranoHome::~CECCyranoHome()
{
}


int CECCyranoHome::GetCyranoHome    (CString &szCyranoHome) const
{
    char CyranoHome[256];
    if (GetEnvironmentVariable (CYRANO_HOME ,CyranoHome ,sizeof (CyranoHome)) <= 0)
    {
        AfxMessageBox ("The CYRANO_HOME Environment variable has not been defined\nPlease re-install the product.");
        return -1;
    }

    //
    //    ...and ensure that it has a trailing slash
    //
    int Length = strlen (CyranoHome);
    if (CyranoHome[Length-1] != '\\')
        (void) strcat (CyranoHome ,"\\");
    szCyranoHome = CyranoHome;
    return 0;
}


int CECCyranoHome::SetCyranoHome    (const CString &CyranoHome) const
{
    //
    //    Ensure that the value passed to us has a trailing slash
    //
    CString szCyranoHome = CyranoHome;
    if (szCyranoHome.Right(1) != '\\')
        szCyranoHome += "\\";

    if (SetEnvironmentVariable (CYRANO_HOME ,szCyranoHome) != 0)
    {
        AfxMessageBox("Failed to set the CYRANO_HOME Environment Variable");
        return -1;
    }
    return 0;
}
