/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CECDataName.h
// -------------
//
//    This is the include file for the CECDataName class
//
//////////////////////////////////////////////////////////////////////////////

//
//    Only load if not already loaded
//
#ifndef CECDataName_Loaded
#define CECDataName_Loaded

/////////////////////////////////////////////////////////////////////////////
// CECDataName window

class CECDataName : public CEdit
{
    // Construction
public:
    void SetData(CString& strDataName);
    void GetData(CString& strDataName, BOOL bUnused = TRUE);
    void SetLength(const int nLength);

    CECDataName();

    // Attributes
public:

    //
    // Over-rides
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECDataName)
public:
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CECDataName();
    BOOL SubclassEdit (UINT nID, CWnd* pParent, WORD wParseStyle);

    //
    //    Static member function which can be called just to validate a dataname.
    //
    static ValidDataName(const CString&  strDataName);
    // Generated message map functions
protected:
    //{{AFX_MSG(CECDataName)
    afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
    //}}AFX_MSG
    afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);

    DECLARE_MESSAGE_MAP()
private:
    BOOL IsCharValid(int nPos,  TCHAR& ch);


    CString m_strValidChars;
    CString m_strSymbols;
    BOOL m_bKeyProcessed;
    BOOL m_bInsert;
    int m_nDataNameLength;
    BOOL m_bSubClassed;
};
#endif
/////////////////////////////////////////////////////////////////////////////


