/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#import "..\..\ActiveX\XServerError\XServerError.tlb" no_namespace named_guids
#include <stdio.h>
#include <stdlib.h>
#include <comdef.h>
#include <objbase.h>
#include <initguid.h>

class CECXServerError
{

public:
    CECXServerError()
    {}
    ;

    void DisplayErrorMessage( CString szProductName, CString szErrorText)
    {

        AfxEnableControlContainer();
        CoInitialize(NULL);

        IXServerErrorCtrlPtr ptrServerError;

        // Create an instance of the server
        try
        {
            HRESULT hr;
            hr = ptrServerError.CreateInstance( CLSID_XServerErrorCtrl );
            if ( FAILED( hr ))
                _com_issue_error( hr );

            LPCTSTR name = szProductName;
            LPCTSTR msg = szErrorText;
            ptrServerError.GetInterfacePtr()->Initialize((unsigned short*)name, (unsigned short*)msg);
        }
        catch( _com_error& e )
        {
            AfxMessageBox( "Error creating instance");
            CString msg;
            msg.Format("HRESULT message is %s",e.ErrorMessage());
            AfxMessageBox(msg);
            msg.Format("Description %s",e.Description());
            AfxMessageBox(msg);
            return;
        }
    };

};
