/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CYRExternalFile.h
// -----------------
//
//    This is the include file for the CYRExternalFile class
//
//=========================================================================
#if !defined(AFX_CYREXTERNALFILE_H__3F5F7178_0F52_11D3_B690_00600856D1F5__INCLUDED_)
#define AFX_CYREXTERNALFILE_H__3F5F7178_0F52_11D3_B690_00600856D1F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CYRExternalFile window
class CYRServer;
class CYRExternalFile : public CObject
{
    // Construction
public:
    CYRExternalFile();

    // Implementation

    // Import a file into the current project
    void Import();

    // Export a file (or files) from the current project
    void Export(CStringArray* arFiles);
    void Export(CString szFileName);

    // Report the status of the operation
    void ReportStatus(char* msg, int nCount);

    // Get hold of a local export directory
    BOOL GetExportDir(CString& szLocalDir);

    // Create an empty file
    BOOL CreateEmptyFile(CString& szEmptyFile);

    BOOL CheckInFile(CString strFilename);
    BOOL CheckOutFile(CString strFilename);

public:
    virtual ~CYRExternalFile();
    CString m_szContext;
    BOOL ImportWebCapture(CString szScriptFile);

private:
    CYRServer *m_pServer;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CYREXTERNALFILE_H__3F5F7178_0F52_11D3_B690_00600856D1F5__INCLUDED_)
