/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_CHANGEDIALOG_H__CD1E8CC6_7579_11D3_9BD8_00600856D346__INCLUDED_)
#define AFX_CHANGEDIALOG_H__CD1E8CC6_7579_11D3_9BD8_00600856D346__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ChangeDialog.h : header file
//
#include "resource.h"
/////////////////////////////////////////////////////////////////////////////
// CChangeDialog dialog

///////////////////////////////////////////////////////////////////////////////
// @class   CChangeDialog | This class represents a dialog that allows the
//          editing of a log setting.
// @base    public | CDialog
class CChangeDialog : public CDialog
{
    // Construction
public:
    CString m_szLevel;                      // @cmember Current level of logging
    CString m_strCategory;                  // @cmember Current name of logging
    BOOL    m_bAllLevels;                   // @cmember Flag to tell us to set this level for all
    CChangeDialog(CWnd* pParent = NULL);    // @cmember Standard constructor

    // Dialog Data
    //{{AFX_DATA(CChangeDialog)
    enum { IDD = IDD_CHANGEDIALOG };
    CComboBox   m_cbLevels;
    CEdit   m_ebCategory;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CChangeDialog)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL
    afx_msg void OnUpdateCategory(CCmdUI* pCmdUI);

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CChangeDialog)
    virtual void OnOK();
    virtual BOOL OnInitDialog();
    afx_msg void OnAllRadio();
    afx_msg void OnCategoryRadio();
    //}}AFX_MSG
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    DECLARE_MESSAGE_MAP()
private:
    CString m_szHtmlHelpFile;
};

///////////////////////////////////////////////////////////////////////////////
// @class   CAddDialog | This class represents a dialog that allows the
//          addition of a log setting.
// @base    public | CDialog
class CAddDialog : public CDialog
{
    // Construction
public:
    CString m_szLevel;                      // @cmember Current level of logging
    CString m_strCategory;                  // @cmember Current name of logging
    CAddDialog(CWnd* pParent = NULL);    // @cmember Standard constructor

    // Dialog Data
    //{{AFX_DATA(CChangeDialog)
    enum { IDD = IDD_ADDDIALOG };
    CComboBox   m_cbLevels;
    CEdit   m_ebCategory;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CChangeDialog)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CChangeDialog)
    virtual void OnOK();
    virtual BOOL OnInitDialog();
    //}}AFX_MSG
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    DECLARE_MESSAGE_MAP()
private:
    CString m_szHtmlHelpFile;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHANGEDIALOG_H__CD1E8CC6_7579_11D3_9BD8_00600856D346__INCLUDED_)
