/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

////////////////////////////////////////////////////////////////////////////////
// @doc     Document
// @module  CECProjectViewerDlg | Dialog to contain and respond to Project Viewer
//          AcitveX control for choosing and opening results
//
////////////////////////////////////////////////////////////////////////////////
//{{AFX_INCLUDES()
#include "cecxprojectviewerwrapper.h"
//}}AFX_INCLUDES



#if !defined(AFX_CECPROJECTVIEWERDLG_H__0BC06A7B_4342_11D3_BE11_00A02456D506__INCLUDED_)
#define AFX_CECPROJECTVIEWERDLG_H__0BC06A7B_4342_11D3_BE11_00A02456D506__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CECProjectViewerDlg.h : header file
//
#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CECProjectViewerDlg dialog

// @class Container for ProjectViewer Control
// @base public | CDialog
class CECProjectViewerDlg : public CDialog
{

    // @access Public Members
public:
    void SetActiveProject(CString szProject);

    // @cmember Constructor
    CECProjectViewerDlg(CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CECProjectViewerDlg)
    enum { IDD = IDD_PROJECT_VIEWER };
    CECXProjectViewerWrapper    m_ProjectViewer;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CECProjectViewerDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual void OnOK();
    virtual void OnCancel();
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CECProjectViewerDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnXChangeActiveProject(LPCTSTR ProjectName);
    afx_msg void OnXOpenTestRun(LPCTSTR TestName, LPCTSTR TestRunName);
    afx_msg void OnXViewResults(LPCTSTR TestName, LPCTSTR TestRunName, short nType);
    DECLARE_EVENTSINK_MAP()
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CECPROJECTVIEWERDLG_H__0BC06A7B_4342_11D3_BE11_00A02456D506__INCLUDED_)
