/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECSourceEditView.cpp : implementation file
//

#include "stdafx.h"
#include "..\..\Interfaces\CyrPlugIns.h"
#include "CECSourceEditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECSourceEditView

IMPLEMENT_DYNCREATE(CECSourceEditView, SECEditView)

CECSourceEditView::CECSourceEditView()
{}


CECSourceEditView::~CECSourceEditView()
{}



BEGIN_MESSAGE_MAP(CECSourceEditView, SECEditView)
//{{AFX_MSG_MAP(CECSourceEditView)
ON_COMMAND(WMU_GET_SRCCTRL_OBJNAME ,OnGetEditedFile)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CECSourceEditView drawing

void CECSourceEditView::OnDraw(CDC* pDC)
{
    CECSourceEditDoc* pDoc = GetDocument();
    // TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CECSourceEditView diagnostics


#ifdef _DEBUG
void CECSourceEditView::AssertValid() const
{
    SECEditView::AssertValid();
}

void CECSourceEditView::Dump(CDumpContext& dc) const
{
    SECEditView::Dump(dc);
}

CECSourceEditDoc* CECSourceEditView::GetDocument() // non-debug version is inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CECSourceEditDoc)));
    return (CECSourceEditDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CECSourceEditView message handlers

SECEdit* CECSourceEditView::GetEdit()
{
    return &GetDocument()->m_Edit;
}

//
// BringToFront
// ============
//
// Bring to the front of the Z_Order
//
void CECSourceEditView::BringToFront()
{
    GetParentFrame()->SetWindowPos(&wndTop,
                                   0, 0, 0, 0,
                                   SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
}


//
// OnGetEditedFileName
// ===============
//
// This function is used to display and set the working folder
//
afx_msg LRESULT CECSourceEditView::OnGetEditedFile()
{
    return (LRESULT) &GetDocument()->GetTitle();
}
