/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
//  CYRThreadDebug.cpp
//  ==================
//
//  This is the implementation file for the CYRThreadDebug Class.
//
////////////////////////////////////////////////////////////////////////////
#ifndef _CYRThreadDebug_
#define _CYRThreadDebug_

#include "resource.h"

class CYRThreadDebug : public CFormView
{
    // Construction
public:
    int DebugWriteMessage(UINT msg, CString& strDiagnostic);
    CYRThreadDebug();   // standard constructor
    DECLARE_DYNCREATE(CYRThreadDebug)

    // Dialog Data
    //{{AFX_DATA(CYRThreadDebug)
    enum { IDD = IDD_THREAD_DEBUG };
    CListCtrl   m_lcSourceCode;
    CString m_strFileName;
    CString m_strThreadName;
    CString m_strDebugOutput;
    CString m_strCurrentStatus;
    //}}AFX_DATA
    virtual void OnInitialUpdate();




    // Attributes
private:
    void UpdateCurrentStatus(CString stStatus);
    int SetListCtrlItem(int nIndex, CString& str, BOOL bNewItem);
    int RetrieveListCtrlItem(int nIndex, CString& str);
    FILE* m_pfileScriptSource;
    int                 m_nLineNumber;          // current line number, -1 error
    CString             m_strThreadRoutingString;
    int                 m_ThreadContext;

    int         DoDebug(BOOL initialising);
    int         ReadScriptFile(CString& strFileName);

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYRThreadDebug)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
    //}}AFX_VIRTUAL
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnDebugStep();
    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CYRThreadDebug)
    afx_msg void OnThreadDebugGo();
    afx_msg void OnDestroy();
    afx_msg void OnClose();
    afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};


#endif
