/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CYRThreadInfo.cpp
// -----------------
//
//    This is the implementation file for the CYRThreadInfo class
//
//=========================================================================

#include "stdafx.h"
#include "CYRThreadInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CYRThreadInfo

CYRThreadInfo::CYRThreadInfo()
{}


CYRThreadInfo::~CYRThreadInfo()
{}

/////////////////////////////////////////////////////////////////////////////
// CYRThreadInfo message handlers

//
// GetTitle
// ========
//
// Return the title of the column being requested


CString CYRThreadInfo::GetTitle(UINT nType)
{
    CString szTitle;

    if      (nType == NAME)     szTitle = "Thread Name";
    else if (nType == DEVICE)   szTitle = "Device Name";
    else if (nType == NODE)     szTitle = "Node Name";
    else if (nType == SCRIPT)   szTitle = "Script Name";
    else if (nType == TIME)     szTitle = "Start Time";
    else if (nType == STATUS)   szTitle = "Status";
    else if (nType == SEQUENCE) szTitle = "Sequence";
    else if (nType == TYPE)     szTitle = "Thread Type";
    else if (nType == MESSAGE)  szTitle = "User Message";

    return szTitle;
}

//
// GetValue
// ========
//
// Return the value of the item being requested

CString CYRThreadInfo::GetValue(UINT nType)
{
    CString szValue;

    if      (nType == NAME)     szValue = m_szThreadName;
    else if (nType == DEVICE)   szValue = m_szDeviceName;
    else if (nType == NODE)     szValue = m_szNodeName;
    else if (nType == SCRIPT)   szValue = m_szScriptName;
    else if (nType == TIME)     szValue = m_szStartTime;
    else if (nType == STATUS)   szValue = m_szStatus;
    else if (nType == SEQUENCE) szValue = m_szSequence;
    else if (nType == TYPE)     szValue = m_szThreadType;
    else if (nType == MESSAGE)  szValue = m_szUserMessage;

    return szValue;
}

//
// SetValue
// ========
//
// Sets the value of a particular item

void CYRThreadInfo::SetValue(UINT nType, CString szValue)
{
    if      (nType == NAME)     m_szThreadName  = szValue;
    else if (nType == DEVICE)   m_szDeviceName  = szValue;
    else if (nType == NODE)     m_szNodeName    = szValue;
    else if (nType == SCRIPT)   m_szScriptName  = szValue;
    else if (nType == TIME)     m_szStartTime   = szValue;
    else if (nType == STATUS)   m_szStatus      = szValue;
    else if (nType == SEQUENCE) m_szSequence    = szValue;
    else if (nType == TYPE)     m_szThreadType  = szValue;
    else if (nType == MESSAGE)  m_szUserMessage = szValue;
}
