/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECGridWnd.cpp : implementation file
//

#include "stdafx.h"
#include "CECGridWnd.h"
#include "CECWebExecDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CECGridWnd

CECGridWnd::CECGridWnd()
{
    m_bInEdit = FALSE;
}

CECGridWnd::~CECGridWnd()
{}



BEGIN_MESSAGE_MAP(CECGridWnd, CECGridCtrl)
//{{AFX_MSG_MAP(CECGridWnd)
ON_WM_RBUTTONDOWN()
ON_WM_LBUTTONUP()
//}}AFX_MSG_MAP
ON_WM_CHAR()
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CECGridWnd message handlers

void CECGridWnd::OnRButtonDown(UINT nFlags, CPoint point)
{
    CMenu menuContext;
    menuContext.LoadMenu(IDR_CONTEXT_MENU);

    CMenu* pPopup = menuContext.GetSubMenu(0);

    CPoint pt(point);
    ClientToScreen(&pt);

    if(pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x,  pt.y,GetParent(), NULL))
    {
        return;
    }

    CECGridCtrl::OnRButtonDown(nFlags, point);
}

void CECGridWnd::OnEndEditCell(int nRow, int nCol, CString str)
{
    CECGridCtrl::OnEndEditCell(nRow, nCol, str);
    m_bInEdit = FALSE;

    CECWebExecDlg* pDlg = (CECWebExecDlg*)GetParent();
    pDlg->UpdateTotals();
}

void CECGridWnd::OnEditCell(int nRow, int nCol, CPoint point, UINT nChar)
{
    CECGridCtrl::OnEditCell(nRow, nCol, point, nChar);

    CECWebExecDlg* pDlg = (CECWebExecDlg*)GetParent();
    pDlg->EditStarted(nRow, nCol);
    m_bInEdit = TRUE;
}

void CECGridWnd::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    // Filter out all charachters other than numeric or Tab
    if (m_bInEdit && !isdigit(nChar) || nChar != VK_TAB)
    {
        return;
    }

    CECGridCtrl::OnChar(nChar, nRepCnt, nFlags);
}

void CECGridWnd::OnLButtonUp(UINT nFlags, CPoint point)
{
    CECGridCtrl::OnLButtonUp(nFlags, point);


    CECWebExecDlg* pDlg = (CECWebExecDlg*)GetParent();
    CCellID id = GetCellFromPt(point);

    CString strCell = GetItemText(id.row, id.col);
    if (atoi(strCell) < 0)
    {
        SetItemText(id.row, id.col, "0");
        RedrawCell(id.row, id.col);
    }

    pDlg->UpdateTotals();
}
