/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/////////////////////////////////////////////////////////////////////////
//
// CYREventSink.h
// --------------
//
//    This is the include file for the CYREventSink class.
//
//=========================================================================
#if !defined(AFX_CYREVENTSINK_H__ED9AF3A3_F889_11D2_B516_00600856D1F5__INCLUDED_)
#define AFX_CYREVENTSINK_H__ED9AF3A3_F889_11D2_B516_00600856D1F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CYREventSink window
class CYRServer;
class CYREventSink : public CWnd
{
    // Construction
public:
    CYREventSink();

    // Workaround for the MFC Memory Management Release Build Issue
    char EventSink[16];

    // Attributes
public:

    // Operations
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CYREventSink)
    //}}AFX_VIRTUAL

    // Implementation
public:
    virtual ~CYREventSink();

    BOOL IsEnabled(UINT nID);

    UINT GetActiveDocument(CString& szFile);

    // Generated message map functions
protected:
    //{{AFX_MSG(CYREventSink)
    afx_msg LRESULT OnSwitchProjects(WPARAM,LPARAM);
    afx_msg LRESULT OnEditProjects(WPARAM,LPARAM);
    afx_msg void OnRecorder();
    afx_msg void OnDesigner();
    afx_msg LRESULT OnTestProperties(WPARAM,LPARAM);
    afx_msg LRESULT OnThreadProperties(WPARAM,LPARAM);
    afx_msg LRESULT OnDelayProperties(WPARAM,LPARAM);
    afx_msg LRESULT OnExecuteWeb(WPARAM,LPARAM);
    //}}AFX_MSG
    afx_msg void OnNewSimpleTest();
    DECLARE_MESSAGE_MAP()

private:
    HWND m_hParent;

    CString     m_CyranoHome;
    CYRServer* m_pServer;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CYREVENTSINK_H__ED9AF3A3_F889_11D2_B516_00600856D1F5__INCLUDED_)
