/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#ifndef _CECNODEDEFINITION_H_
#define _CECNODEDEFINITION_H_

///////////////////////////////////////////////////////////////////////////////
// @doc     CECNodeDefinition
// @module  CECNodeDefinition|Encapsulate node definition for TestInitiators
///////////////////////////////////////////////////////////////////////////////

#include <string>
#include <CECInetInfo.h>
#ifndef CYR_NO_STD_NAMESPACE
using std::string;
#endif
class CECNodeDefinition
{
public:
    CECNodeDefinition(const string& NodeName);
    CECNodeDefinition(const CECNodeDefinition& NodeDef);
    virtual ~CECNodeDefinition();

    string  GetNodeIPAddrAsString()const;
protected:
    // @cmember Determine if the specified node is localhost
    bool    LocalHost()const;

private:
    string      m_Node;     //Node Address as passed to constructor
    CECInetInfo     m_InetInfo;
};
#endif
