/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#ifndef _CECSPAWNOBJECT_H_
#define _CECSPAWNOBJECT_H_
///////////////////////////////////////////////////////////////////////////////
// @doc     CECSpawnObject
// @module  CECSpawnObject |    Find a factory on the appropriate node
//              Create Spawn process of appropriate type
//              Attach to the object created by process
///////////////////////////////////////////////////////////////////////////////
#include <OSTAORB/OSTAORB.h>
#include <Factory/Factory.h>
#include <Objects/SpawnProc.h>
#include "CECNodeDefinition.h"
#define     TP_TRACE_LEVEL  "TP_TRACE_LEVEL"
extern "C"
{
#include <psl_macros.h>
#include <target_rtndef.h>
}

class CECSpawnObject
{
public:
    CECSpawnObject(const CECNodeDefinition& Node,const string& product,TARGETIMAGE imageid,TARGETID targetid,const string& params,const string& ClassName,const string& ExpectedName,CORBAServer* CS=NULL);
    virtual ~CECSpawnObject();
    virtual CORBA::Object_ptr RetrieveObject();
protected:
    virtual bool FindDebugProcess();
    virtual void AttachToFactory();
    virtual void CreateSpawnProcess();
    virtual void AttachToObject();
private:
    CORBAServer* m_pCORBAServer;
    CECNodeDefinition  m_NodeDefinition;
    string  m_ClassName;
    string  m_ExpectedName;
    string   m_Product;
    TARGETIMAGE  m_Exe;
    TARGETID     m_Target;
    string   m_Params;
    string   m_strPID;
    CyrFactory_var    m_Factory;
    CORBA::Object_var m_Object;

};
#endif
