/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N ****                   */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: PSL_STRUCTURES              */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  This File contains Incomplete Type Declarations for all structure    */
/*  types defined in common function prototype files.            */
/*                                       */
/*                                       */
/*===========================================================================*/

#ifndef PSL__PSL_STRUCTURES_LOADED
#define PSL__PSL_STRUCTURES_LOADED 1


#ifdef VMS
struct  dsc$descriptor_s;       /* VMS Descriptor Format */
#endif /* VMS */

struct  diagstk;            /* Diagnostics Stack */
struct  errtrap;            /* Error Trap */
struct  fdr_act;            /* FDR Action Item */
struct  fdr_frm;            /* Form Header */
struct  fdr_gen;            /* FDR Generic Structure */
struct  fdr_gph;            /* FDR GPH Structure */
struct  fdr_hed;            /* FDR HED Structure */
struct  fdr_ifl;            /* FDR IFL Structure */
struct  fdr_imn;            /* FDR Internal Menu Structure */
struct  fdr_mnu;            /* FDR Menu Structure */
struct  fdr_ofl;            /* FDR OFL Structure */
struct  fdr_rcrs;           /* FDR Recursion Structure */
struct  fdr_rgp;            /* FDR Repeat Group */
struct  fdr_val;            /* FDR Value Structure */
struct  gendmp_com;         /* GENDMP Common Data */
struct  ipc_ctx;            /* IPC routines context */
struct  ipc_hed;            /* IPC Header record */
struct  ipc_exprsp;         /* IPC Expected/valid response */
struct  itemlist;           /* Itemlist structure */
struct  itemlist2;          /* Itemlist structure */
struct  ldb;                /* Library Defn Block */
struct  list_ctx;           /* Listing routines */
struct  psl_vm_llb;         /* Linked Lists */
struct  psl_dsdat;          /* Statistical display structure */
struct  psl_vm_skey;            /* LL Sort Key structure */
struct  pslmem_ctx;         /* PSLMEM Context Block */
struct  scrimg;             /* Screen Image Structure */
struct  scr_dat;            /* Screen Image Data Structure */

struct  scr_fil;            /* New scr image file struct */

struct  scr_hdr;            /* Screen Image Header Structure */

struct  scr_ifi;            /* Internal Screen Image File Struct */

struct  scr_img;            /* New screen image structure */

struct  scr_old;            /* Old Screen Image Structure */

struct  scr_rec;            /* Screen Image Record Structure */

struct  scr_wrk;            /* Screen Image Work Structure */

struct  tcb;                    /* Terminal Control Block */
struct  tdb;                /* TPARSE Definition Block */
struct  tpaarg;             /* TPARSE Argument Block */
struct  tpatab;             /* TPARSE Tables */
struct  trace_keywords;         /* Trace Keywords */
struct  vrfv14;             /* VRF V14 file structure */
struct  vrf_fil;            /* VRF context block */
struct  vtl;                /* VTL CTM ATF structure */

#endif  /* PSL__PSL_STRUCTURES_LOADED */
